## How to contribute to PACE Bricks

#### **Did you find a bug?**

* **Do not open up a GitHub issue if the bug is a security vulnerability
  in PACE Bricks**, and instead email the security team `security at pace.car`.

* **Ensure the bug was not already reported** by searching on GitHub under [Issues](https://github.com/pace/bricks/issues).

* If you're unable to find an open issue addressing the problem, [open a new one](https://github.com/pace/bricks/issues/new). Be sure to include a **title and clear description**, as much relevant information as possible, and a **code sample** or an **executable test case** demonstrating the expected behavior that is not occurring.

* If possible, use the relevant bug report templates to create the issue. Simply copy the content of the appropriate template into a file, make the necessary changes to demonstrate the issue, and **paste the content into the issue description**.

#### **Did you write a patch that fixes a bug?**

* Open a new GitHub pull request with the patch.

* Ensure the PR description clearly describes the problem and solution. Include the relevant issue number if applicable.

#### **Did you fix whitespace, format code, or make a purely cosmetic patch?**

Changes that are cosmetic in nature and do not add anything substantial to the stability, functionality, or testability of PACE Bricks will generally not be accepted. Code needs to be formatted with go fmt.

Thanks! :heart: :heart: :heart:

PACE Team
